import math
import itertools
def learn_theta(data, colors):
    red_min = math.inf
    blue_max = -math.inf
    for i in range(len(data)):
        if colors[i] == "red" and data[i] < red_min: 
            red_min = data[i]
        elif colors[i] == 'blue' and data[i] > blue_max:
            blue_max = data[i]
            
    return (red_min + blue_max)/2

def compute_ell(data, colors, theta):
    no_red_less = 0
    no_blue_more = 0
    for i in range(len(data)):
        if colors[i] == 'red' and data[i] <= theta:
            no_red_less += 1
        elif colors[i] == 'blue' and data[i] > theta:
            no_blue_more += 1

            
    return no_red_less + no_blue_more

def minimize_ell(data, colors):
    min_L = math.inf
    min_theta = None
    combs = itertools.combinations(range(len(data)), 2)
    for comb in combs:
        theta = (data[comb[0]] + data[comb[1]])/2
        temp_L = compute_ell(data, colors, theta)
        if temp_L < min_L:
            min_L = temp_L
            min_theta = theta
            
    return min_theta

def minimize_ell_sorted(data, colors):
    blue_gt_theta = len(data)/2
    red_lte_theta = 0
    loss = math.inf
    theta = math.inf
    for i in range(len(data)):
        if colors[i] == 'red':
            red_lte_theta += 1
            if red_lte_theta + blue_gt_theta < loss:
                loss = red_lte_theta + blue_gt_theta
                theta = data[i]
        elif colors[i] == 'blue':
            blue_gt_theta -= 1
            if red_lte_theta + blue_gt_theta < loss:
                loss = red_lte_theta + blue_gt_theta
                theta = data[i]
                
    return theta